--=====================================
-- Author      : Txty
-- Create Date : 8/21/2020 12:27:36 AM
--=====================================
local _, namespace = ...
local menuFrame = CreateFrame("Frame", "ExampleMenuFrame", UIParent, "UIDropDownMenuTemplate")
local myButt = {}
-------------------------------------
function namespace.myButtons(button, whatToDo)
	if whatToDo == "insert" then table.insert(myButt, button)
	elseif whatToDo == "hide" then 
		for i=1, #myButt do myButt[i]:Hide() end
	elseif whatToDo == "show" then
		for i=1, #myButt do myButt[i]:Show() end
	end
end
-------------------------------------
-- Frame
-------------------------------------
local function SetupDHFrame(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
--	frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	-- The code below makes the frame visible
	frame:SetBackdrop({
--		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark", tile = true, tileSize = 20,
		edgeFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 42,
		insets = { left = 10, right = 10, top = 10, bottom = 10 }
		})
--	frame:SetSize(1*40+18, 6*40+18)
	frame:SetClampedToScreen(true)
	return frame
end
-------------------------------------
local function LocationButton_OnClick(self, mouseButton)
--	DungeonHelper2:Print(self:GetParent():GetName())
--	local frame = self:GetParent()
	menuFrame:SetPoint("Center", DungeonHelper2, "BOTTOMRIGHT")
	local name = string.sub(self.location,1,4)
	if namespace.config.db.char.lock == false then  -- opacity 0.5 Unlocked
		if mouseButton == "RightButton" then
			EasyMenu(namespace.menu, menuFrame, menuFrame, 20, 190, "MENU");			
		end	
	elseif namespace.config.db.char.lock == true then  -- opacity 1 Locked
		if mouseButton == "RightButton" and name == "icon" then
			EasyMenu(namespace.menu1, menuFrame, menuFrame, 20, 235, "MENU");
		elseif mouseButton == "RightButton" and (name == "8" or name == "7") then
			EasyMenu(namespace.menu2, menuFrame, menuFrame, 20, 205, "MENU");
--		elseif mouseButton == "RightButton" and name == "Bull" then
--			EasyMenu(namespace.menu3, menuFrame, menuFrame, 20, 200, "MENU"); -- is not in use, for ex. pullTimer()
		elseif mouseButton == "LeftButton" then
			if name == "Bull" then
				DoReadyCheck()
			elseif name == ("7") or name == ("8") then
				SetRaidTargetIcon("target",tonumber(name))
			else
				EasyMenu(namespace.menu4, menuFrame, menuFrame, 20, 190, "MENU");
			end
		end
	end
end
-------------------------------------
-- Buttons
-------------------------------------
local function AddLocationButton(frameName, name, texture)
   local button = CreateFrame("Button", nil, frameName, "SecureActionButtonTemplate")
   button:SetSize(40, 40)
   button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
   button:SetScript("OnClick", LocationButton_OnClick)

   -- Store the location name on the button:
   button.location = name
   -- Apply the specified texture:
   button:SetNormalTexture("Interface\\AddOns\\DungeonHelper2\\Icons\\"..texture)
   button:SetHighlightTexture("Interface\\AddOns\\DungeonHelper2\\Icons\\highlight")

   -- Store the button on the frame:
   frameName.locations = frameName.locations or {}
   tinsert(frameName.locations, button)

   -- Automatically place the button:
   local i = #frameName.locations
   --print(i)
   if i <= 3 then namespace.myButtons(button, "insert") end
   if i == 1 then
      button:SetPoint("TOPRIGHT", -9, -10)
   else
	  button:SetPoint("TOPLEFT", frameName.locations[i-1], "BOTTOMLEFT")
   end	
   return button
end
-------------------------------------
-- Create Frames and Buttons
-------------------------------------
local function createF(frameName)
	SetupDHFrame(frameName)
--------------
-- Buttons	
--------------
	-- frameName
	AddLocationButton(frameName, "icon1", "icons1")
	AddLocationButton(frameName, "icon2", "icons2")
	AddLocationButton(frameName, "icon3", "icons3")
	AddLocationButton(frameName, "7", "cross")
	AddLocationButton(frameName, "8", "skull")
	AddLocationButton(frameName, "Bull", "pull")
end
-------------------------------------
-- Create Frames and Buttons
-------------------------------------
function namespace.init(frameName)
	local frame = CreateFrame('Frame', framename, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	createF(frame)
	return frame
end
-- END ------------------------------